﻿/// <reference path="../jquery-2.1.4.min.js" />
/// <reference path="RemotingClickToChat.js" />
/// <reference path="../knockout-3.4.0.js" />
$(function () {
    var viewModel = function () {
        var self = this;
        var userNameCookieID = "userName",
            chatCollapsedCookieID = "chatCollapsed";

        var selfImage = "~/anon.png";
        var RemotingCodersImage = "~/remcod.png";
        self.TextBox = ko.observable();
        
        if (docCookies.getItem(userNameCookieID) == null) {
            docCookies.updateItem(userNameCookieID, "Anonymous-" + Math.floor((Math.random() * 100) + 1).toString(), undefined, "/");
        }

        self.UserName = ko.observable(docCookies.getItem(userNameCookieID) || "Anonymous-" + Math.floor((Math.random() * 100) + 1).toString());
        self.UserName.subscribe(function (newValue) {
            docCookies.updateItem(userNameCookieID, newValue, undefined, "/");
        });
        self.Messages = ko.observableArray([]);
        self.InEditMode = ko.observable(false);
        self.UserNameValue = ko.observable();
        self.SendMessage = function () {
            if (self.Enabled()) {
                if (!chat)
                    self.OpenChat();
                if (self.TextBox()) {
                    chat.SendMessage(self.TextBox());
                    self.TextBox("");
                }
            }
        }
        self.IsBusy = ko.observable(false);

        self.ChatCollapsed = ko.observable(docCookies.getItem(chatCollapsedCookieID) === "true");
        self.ChatCollapsed.subscribe(function (newValue) {
            docCookies.updateItem(chatCollapsedCookieID, newValue, undefined, "/");
        });
        if (self.ChatCollapsed()) {
            $("#chat").slideToggle(0);
        }
        self.toggleChat = function (data, ev) {
            if (ev.target.tagName.toLowerCase() != "a" &&
                ev.target.tagName.toLowerCase() != "input" &&
                (ev.target.tagName.toLowerCase() != "i" || ev.target.className.indexOf("-chevron-") != -1))
                $("#chat").slideToggle(250, function () { self.ChatCollapsed(!self.ChatCollapsed()); });


        }
        self.EditUserNameClick = function () {
            self.InEditMode(true);
            $("#username-input").focus().select();
        }


        self.KeyPressedUserName = function (data, ev) {
            if (ev.which == 13) {
                self.DoneEditing();
                ev.preventDefault();
            }
            else if (ev.which == 27) {
                if (self.UserNameValue())
                    self.UserName(self.UserNameValue());
                self.InEditMode(false);
            }
            return true;
        }

        self.DoneEditing = function () {
            if ($("#username-input").val()) {
                self.InEditMode(false);
                if (chat)
                    chat.ChangeSubject($("#username-input").val());
                self.UserNameValue($("#username-input").val());
            }
        }
        var MessageGuids = [],
            MessageAlreadyExists = function (messageID) {
                for (var ii = 0; ii < MessageGuids.length; ii++) {
                    if (messageID == MessageGuids[ii]) {
                        return true;
                    }
                }
                MessageGuids.push(messageID);
                return false;
            }
        self.KeyPressed = function (data, ev) {
            if (self.Enabled()) {
                if (ev.which == 13) {
                    self.SendMessage();
                    ev.preventDefault();
                }
                else if (ev.which == 27) {
                    self.TextBox("");
                    ev.preventDefault();
                }
                return true;
            }
        }
        self.Enabled = ko.observable(true);

        self.IsTyping = ko.observable(false);

        self.showLoading = ko.observable(false);

        self.OpenChat = function () {
            chat = new RemotingClickToChat({ UserName: "#username-h4 span", AvailavilityChanged: self.AvailavilityChanged, MessageReceived: self.MessageReceived })
            chat
                .on(RemotingClickToChat.Events.BeforeCreateConversation, function () { self.showLoading(true); self.Enabled(false); })
                .on(RemotingClickToChat.Events.AfterCreateConversation, function () { self.showLoading(false); self.Enabled(true); })
                .on(RemotingClickToChat.Events.BeforeSendMessage, function () { self.showLoading(true); })
                .on(RemotingClickToChat.Events.AfterSendMessage, function () { self.showLoading(false); })
                .on(RemotingClickToChat.Events.IsTypingChanged, function (result) { self.IsTyping(result); })
                .on(RemotingClickToChat.Events.OnError, function (result) {
                    if (result && result.Data && result.Data.MethodName) {
                        if (result.Data.MethodName == "IsTyping") {
                            self.IsTyping(false);
                        }
                        else if (result.Data.MethodName == "OpenConversation") {
                        }
                    }
                })
                .on(RemotingClickToChat.Events.OnServerAvailabilityChanged, function (state) {
                    self.IsBusy(!!!state.newState);
                });;

        }
        self.AvailavilityChanged = function (results) {
            self.IsBusy(results.indexOf("DoNotDisturb") != -1 || results.indexOf("Invalid") != -1);
        }
        function formatAMPM(date) {
            var hours = date.getHours();
            var minutes = date.getMinutes();
            var ampm = hours >= 12 ? 'pm' : 'am';
            hours = hours % 12;
            hours = hours ? hours : 12; // the hour '0' should be '12'
            minutes = minutes < 10 ? '0' + minutes : minutes;
            var strTime = hours + ':' + minutes + ' ' + ampm;
            return strTime;
        }

        self.MessageReceived = function (results) {            
            var data = results.Data.Messages.sort(function (a, b) {
                if (a.MessageTime < b.MessageTime)
                    return -1;
                if (a.MessageTime > b.MessageTime)
                    return 1;
                return 0;

            });
            for (var ii = 0; ii < data.length; ii++) {
                var item = results.Data.Messages[ii];
                if (!MessageAlreadyExists(item.MessageID)) {
                    item.Message = item.ParticipantName == "You" ? $('<div/>').text(item.Message).html() : item.Message;
                    var lastMessage = self.Messages()[self.Messages().length - 1];

                    var d = new Date(item.CreatedDateTime);
                    d = new Date(d.getTime() - d.getTimezoneOffset() * 60000);

                    if (lastMessage && lastMessage.ParticipantUri == item.ParticipantUri) {
                        lastMessage.MessageTexts.push(item.Message);
                        //lastMessage.MessageTime(formatAMPM(new Date()));

                        lastMessage.MessageTime(formatAMPM(d));
                    }
                    else {
                        lastMessage = {
                            //MessageTime: ko.observable(formatAMPM(new Date())),
                            MessageTime: ko.observable(formatAMPM(d)),
                            _ParticipantName: ko.observable(item.ParticipantName),
                            ParticipantName: item.ParticipantName == "You" ? self.UserName : item.ParticipantName,
                            ParticipantUri: item.ParticipantUri,
                            ParticipanImg: ko.observable(item.ParticipantName == "You" ? selfImage : RemotingCodersImage),
                            MessageTexts: ko.observableArray([item.Message]),
                            isAdmin: item.isAdmin
                        };
                        self.Messages.push(lastMessage);
                    }
                }
            }

            if (data.length > 0) {
                $(".chat-widget").scrollTop($(".chat-widget")[0].scrollHeight);
                self.IsTyping(false);
            }
        }
        var chat = undefined;
        self.OpenChat();
    }
    ko.applyBindings(new viewModel());
});